import { AnyT } from '../definitions.interface';
import { IChannelsEntity } from '../entities-definitions.interface';
import { PayloadWrapper } from './protocol';
/**
 * @stable [21.05.2018]
 */
export interface IChannelClient {
    on(event: string, callback: (...args: AnyT[]) => void): void;
    emit(event: string, ...args: AnyT[]): void;
    close(): void;
}
/**
 * @stable [21.05.2018]
 */
export interface IChannel {
    connect(ip: string, config?: AnyT): void;
    disconnect(ip: any): void;
    onConnect(ip: string, client: IChannelClient): void;
    onDisconnect(ip: string, client: IChannelClient): void;
    onMessage(ip: string, client: IChannelClient, name: string, message?: string): void;
    emitEvent(ip: string, event: string, ...messages: AnyT[]): void;
    emitChannelEvent(ip: string, ...messages: AnyT[]): void;
    emitRequestPayload(ip: string, requestPayload: PayloadWrapper): void;
}
/**
 * @stable [20.05.2018]
 */
export declare const INITIAL_APPLICATION_CHANNEL_STATE: IChannelsEntity;
export declare const CHANNEL_CONNECT_MESSAGE = "connect";
export declare const CHANNEL_DISCONNECT_MESSAGE = "disconnect";
export declare const $CHANNEL_MESSAGE_ACTION_TYPE: string;
export declare const $CHANNEL_CONNECTED_ACTION_TYPE: string;
export declare const $CHANNEL_DISCONNECTED_ACTION_TYPE: string;
