import { AnyT } from '../../definitions.interface';
import { CommandParam } from './command.param';
/**
 * @stable [21.05.2018]
 */
export declare class Command {
    static readonly $PROTOCOL_PAYLOAD_CLASS_IDENTIFIER: string;
    /**
     * @stable [21.05.2018]
     * @returns {Command}
     */
    static newCommand(): Command;
    private command;
    private params;
    private uuid;
    /**
     * @stable [21.05.2018]
     * @param {string} uuid0
     * @returns {Command}
     */
    setUuid(uuid0: string): Command;
    /**
     * @stable [21.05.2018]
     * @param {string} command
     * @returns {Command}
     */
    setCommand(command: string): Command;
    /**
     * @stable [21.05.2018]
     * @param {string} paramName
     * @param {AnyT} paramValue
     * @returns {Command}
     */
    addParam(paramName: string, paramValue: AnyT): Command;
    /**
     * @stable [21.05.2018]
     * @returns {string}
     */
    getCommand(): string;
    /**
     * @stable [21.05.2018]
     * @returns {string}
     */
    getUuid(): string;
    /**
     * @stable [21.05.2018]
     * @returns {CommandParam[]}
     */
    getParams(): CommandParam[];
}
