"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_1 = require("vue");
var util_1 = require("../../util");
var di_1 = require("../../di");
var dictionary_1 = require("../../dictionary");
var vue_index_1 = require("../form/vue-index");
var vue_index_2 = require("../list/vue-index");
var vue_index_3 = require("../../router/vue-index");
var VueBaseContainer = /** @class */ (function (_super) {
    __extends(VueBaseContainer, _super);
    function VueBaseContainer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Object.defineProperty(VueBaseContainer.prototype, "state$", {
        /**
         * @stable [21.10.2018]
         * @returns {IVueApplicationStoreEntity}
         */
        get: function () {
            return this.store$.getState();
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [18.11.2018]
     * @param {string} type
     * @param {TChanges} data
     */
    VueBaseContainer.prototype.dispatch = function (type, data) {
        this.dispatchCustomType(this.section$ + "." + type, util_1.applySection(this.section$, data));
    };
    /**
     * @stable [13.11.2018]
     * @param {TChanges} changes
     */
    VueBaseContainer.prototype.dispatchFormChanges = function (changes) {
        this.store$.dispatch(vue_index_1.FormActionBuilder.buildChangesSimpleAction(this.section$, changes));
    };
    /**
     * @stable [18.11.2018]
     * @param {string} fieldName
     * @param {AnyT} fieldValue
     */
    VueBaseContainer.prototype.dispatchFormChange = function (fieldName, fieldValue) {
        this.store$.dispatch(vue_index_1.FormActionBuilder.buildChangeSimpleAction(this.section$, fieldName, fieldValue));
    };
    /**
     * @stable [19.11.2018]
     */
    VueBaseContainer.prototype.dispatchFormSubmit = function () {
        this.dispatchCustomType(vue_index_1.FormActionBuilder.buildSubmitActionType(this.section$));
    };
    /**
     * @stable [18.11.2018]
     * @param {string} dictionary
     * @param {TData} data
     */
    VueBaseContainer.prototype.dispatchLoadDictionary = function (dictionary, data) {
        this.dispatchCustomType(dictionary_1.DictionariesActionBuilder.buildLoadActionType(dictionary), util_1.applySection(dictionary, data));
    };
    /**
     * @stable [21.10.2018]
     * @param {string} type
     * @param {AnyT} data
     */
    VueBaseContainer.prototype.dispatchCustomType = function (type, data) {
        this.store$.dispatch({ type: type, data: data });
    };
    /**
     * @stable [25.10.2018]
     */
    VueBaseContainer.prototype.navigateToBack = function () {
        this.dispatchCustomType(vue_index_3.ROUTER_BACK_ACTION_TYPE);
    };
    /**
     * @stable [25.10.2018]
     */
    VueBaseContainer.prototype.dispatchListCreate = function () {
        this.dispatch(vue_index_2.LIST_CREATE_ACTION_TYPE);
    };
    /**
     * @stable [25.10.2018]
     * @param {IEntity} entity
     */
    VueBaseContainer.prototype.dispatchListSelect = function (entity) {
        var payload = { selected: entity };
        this.dispatch(vue_index_2.LIST_SELECT_ACTION_TYPE, payload);
    };
    /**
     * @stable [25.10.2018]
     * @param {TPath0} path
     * @param {TState0} state
     */
    VueBaseContainer.prototype.navigate = function (path, state) {
        var payload = { path: path, state: state };
        this.dispatchCustomType(vue_index_3.ROUTER_NAVIGATE_ACTION_TYPE, payload);
    };
    /**
     * @stable [17.11.2018]
     * @returns {VueBaseContainer}
     */
    VueBaseContainer.prototype.getSelf = function () {
        return this;
    };
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Store),
        __metadata("design:type", Object)
    ], VueBaseContainer.prototype, "store$", void 0);
    __decorate([
        di_1.lazyInject(di_1.DI_TYPES.Translate),
        __metadata("design:type", Function)
    ], VueBaseContainer.prototype, "t", void 0);
    return VueBaseContainer;
}(vue_1.default));
exports.VueBaseContainer = VueBaseContainer;
//# sourceMappingURL=vue-base.container.js.map