"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var util_1 = require("../../../util");
var layout_1 = require("../../layout");
var base_checkbox_component_1 = require("./base-checkbox.component");
var Checkbox = /** @class */ (function (_super) {
    __extends(Checkbox, _super);
    function Checkbox() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [31.08.2018]
     * @returns {JSX.Element}
     */
    Checkbox.prototype.render = function () {
        var props = this.props;
        return (React.createElement("div", { className: this.getFieldClassName() },
            React.createElement(layout_1.FlexLayout, { className: 'rac-self-field-wrapper', row: true, alignItemsCenter: true },
                React.createElement("div", { ref: 'self', style: props.style, className: this.getSelfElementClassName() },
                    React.createElement("div", { className: this.getInputElementWrapperClassName() },
                        this.getInputElement(),
                        this.getInputAttachmentElement())),
                this.getLabelElement()),
            this.getMessageElement(),
            props.required && this.getErrorMessageElement()));
    };
    /**
     * @stable [31.08.2018]
     * @returns {JSX.Element}
     */
    Checkbox.prototype.getInputAttachmentElement = function () {
        return this.uiFactory.makeCheckboxAttachment();
    };
    /**
     * @stable [31.08.2018]
     * @returns {ICheckboxInputProps}
     */
    Checkbox.prototype.getInputElementProps = function () {
        return __assign({}, _super.prototype.getInputElementProps.call(this), { className: this.uiFactory.checkboxInput });
    };
    /**
     * @stable [31.08.2018]
     * @returns {string}
     */
    Checkbox.prototype.getFieldClassName = function () {
        return util_1.toClassName(_super.prototype.getFieldClassName.call(this), 'rac-checkbox');
    };
    /**
     * @stable [31.08.2018]
     * @returns {JSX.Element}
     */
    Checkbox.prototype.getSelfElementClassName = function () {
        return util_1.toClassName(this.uiFactory.checkbox, 'rac-checkbox-field');
    };
    return Checkbox;
}(base_checkbox_component_1.BaseCheckbox));
exports.Checkbox = Checkbox;
//# sourceMappingURL=checkbox.component.js.map