import { VueField } from '../field/vue-index';
import { MultiFieldPlugin } from '../multifield/vue-index';
import { IMultiItemEntity } from '../../../entities-definitions.interface';
export declare class VueBaseFileField extends VueField {
    protected type: string;
    protected multiFieldPlugin: MultiFieldPlugin;
    private cachedFiles;
    /**
     * @stable [27.11.2018]
     */
    constructor();
    /**
     * @stable [25.11.2018]
     * @returns {string}
     */
    getFieldClassName(): string;
    /**
     * @stable [28.11.2018]
     * @param {File[]} files
     * @returns {string[]}
     */
    onFilesSelect(files: File[]): string[];
    /**
     * @stable [17.11.2018]
     * @returns {string}
     */
    protected getInputClassName(): string;
    /**
     * @stable [28.11.2018]
     * @returns {string}
     */
    protected getFieldAttachmentTemplate(): string;
    /**
     * @stable [28.11.2018]
     * @param {string} fileUrl
     */
    protected addFile(fileUrl: string): void;
    /**
     * @stable [28.11.2018]
     * @param {IMultiItemEntity} fileEntity
     */
    protected removeFile(fileEntity: IMultiItemEntity): void;
    /**
     * @stable [28.11.2018]
     * @param {string} fileUrl
     */
    protected destroyFileUrl(fileUrl: string): void;
}
