"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_property_decorator_1 = require("vue-property-decorator");
var util_1 = require("../../../util");
var vue_index_1 = require("../field/vue-index");
var vue_index_2 = require("../multifield/vue-index");
var VueBaseFileField = /** @class */ (function (_super) {
    __extends(VueBaseFileField, _super);
    /**
     * @stable [27.11.2018]
     */
    function VueBaseFileField() {
        var _this = _super.call(this) || this;
        _this.multiFieldPlugin = new vue_index_2.MultiFieldPlugin(_this);
        _this.cachedFiles = new Set();
        _this.onFilesSelect = _this.onFilesSelect.bind(_this);
        return _this;
    }
    /**
     * @stable [25.11.2018]
     * @returns {string}
     */
    VueBaseFileField.prototype.getFieldClassName = function () {
        return _super.prototype.getFieldClassName.call(this) + " vue-file-field";
    };
    /**
     * @stable [28.11.2018]
     * @param {File[]} files
     * @returns {string[]}
     */
    VueBaseFileField.prototype.onFilesSelect = function (files) {
        var _this = this;
        return Array.from(files).map(function (file) {
            var url = URL.createObjectURL(file);
            _this.cachedFiles.add(url);
            _this.addFile(url); // TODO Need to many files handling
            return url;
        });
    };
    /**
     * @stable [17.11.2018]
     * @returns {string}
     */
    VueBaseFileField.prototype.getInputClassName = function () {
        return _super.prototype.getInputClassName.call(this) + " rac-flex-full";
    };
    /**
     * @stable [28.11.2018]
     * @returns {string}
     */
    VueBaseFileField.prototype.getFieldAttachmentTemplate = function () {
        return util_1.orDefault(this.hasValue(), function () { return ("<component :is=\"getViewerComponent()\"\n                    v-on=\"getViewerListeners()\"\n                    v-bind=\"getViewerBindings()\"/>"); }, function () { return ("<vue-dnd :defaultMessage=\"getMessage()\"\n                  @select=\"onFilesSelect\"/>"); });
    };
    /**
     * @stable [28.11.2018]
     * @param {string} fileUrl
     */
    VueBaseFileField.prototype.addFile = function (fileUrl) {
        this.multiFieldPlugin.onAddItem({ id: fileUrl, newEntity: true });
    };
    /**
     * @stable [28.11.2018]
     * @param {IMultiItemEntity} fileEntity
     */
    VueBaseFileField.prototype.removeFile = function (fileEntity) {
        this.multiFieldPlugin.onDeleteItem(fileEntity);
        this.destroyFileUrl(fileEntity.id);
    };
    /**
     * @stable [28.11.2018]
     * @param {string} fileUrl
     */
    VueBaseFileField.prototype.destroyFileUrl = function (fileUrl) {
        this.cachedFiles.delete(fileUrl);
        URL.revokeObjectURL(fileUrl);
    };
    __decorate([
        vue_property_decorator_1.Prop({ default: function () { return 'hidden'; } }),
        __metadata("design:type", String)
    ], VueBaseFileField.prototype, "type", void 0);
    return VueBaseFileField;
}(vue_index_1.VueField));
exports.VueBaseFileField = VueBaseFileField;
//# sourceMappingURL=vue-base-filefield.component.js.map