"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var vue_property_decorator_1 = require("vue-property-decorator");
var R = require("ramda");
var util_1 = require("../../../util");
var vue_index_1 = require("../../connector/vue-index");
var vue_index_2 = require("../multifield/vue-index");
var vue_base_filefield_component_1 = require("./vue-base-filefield.component");
var VueMultiFileField = /** @class */ (function (_super) {
    __extends(VueMultiFileField, _super);
    /**
     * @stable [28.11.2018]
     */
    function VueMultiFileField() {
        var _this = _super.call(this) || this;
        _this.getFiles = _this.getFiles.bind(_this);
        return _this;
    }
    /**
     * @stable [25.11.2018]
     * @param {VueCreateElementFactoryT} createElement
     * @returns {VueNodeT}
     */
    VueMultiFileField.prototype.render = function (createElement) {
        return _super.prototype.render.call(this, createElement);
    };
    /**
     * @stable [28.11.2018]
     * @param newValue
     * @param {AnyT} context
     */
    VueMultiFileField.prototype.onChangeManually = function (newValue, context) {
        _super.prototype.onChangeManually.call(this, newValue, context);
    };
    VueMultiFileField.prototype.getFiles = function () {
        var totalFilesCount = 6;
        var relations = util_1.generateArray(totalFilesCount);
        var actualRelations = vue_index_2.toActualMultiItemEntities(this.getValue());
        if (Array.isArray(actualRelations)) {
            var isFullFilled = actualRelations.length === totalFilesCount;
            var startIndex_1 = isFullFilled ? 0 : 1;
            actualRelations.forEach(function (actualRelation, index) {
                relations[index + startIndex_1] = actualRelation;
            });
        }
        return relations;
    };
    /**
     * @stable [27.11.2018]
     * @returns {string}
     */
    VueMultiFileField.prototype.getFieldAttachmentTemplate = function () {
        return ("<div class=\"vue-field-attachment-wrapper\">\n          <template v-for=\"file in getFiles()\">\n            <component v-if=\"file\"\n                       :is=\"getViewerComponent()\"\n                       v-on=\"getViewerListeners(file)\"\n                       v-bind=\"getViewerBindings(file)\"/>\n            <vue-dnd v-if=\"!file\"\n                    :defaultMessage=\"getMessage()\"\n                    @select=\"onFilesSelect\"/>\n          </template>\n       </div>");
    };
    VueMultiFileField.prototype.getTemplateMethods = function () {
        var _this = this;
        return __assign({}, _super.prototype.getTemplateMethods.call(this), { getViewerComponent: function () { return 'vue-cropper-viewer'; }, getViewerListeners: function (fileEntity) { return ({
                change: function (blob) {
                    var newFileUrl = URL.createObjectURL(blob);
                    if (fileEntity.newEntity) {
                        _this.removeFile(fileEntity);
                        _this.$nextTick(function () { return _this.addFile(newFileUrl); });
                    }
                    else {
                        _this.multiFieldPlugin.onEditItem({ id: fileEntity.id, name: _this.displayName, value: newFileUrl });
                    }
                },
                remove: function () { return _this.removeFile(fileEntity); },
            }); }, getViewerBindings: function (relation) {
                if (relation.newEntity) {
                    return { src: relation.id };
                }
                var relationId = relation.id;
                if (R.isNil(relationId)) {
                    return {};
                }
                var files = _this.getFiles();
                var existedRelation = files.find(function (itm) { return itm && itm.id === relationId; });
                var fileUrl = R.isNil(existedRelation) ? relationId : Reflect.get(existedRelation, _this.displayName);
                // TODO
                return R.isNil(fileUrl)
                    ? {}
                    : ({ src: fileUrl.startsWith('blob:')
                            ? fileUrl
                            : 'https://images.pexels.com/photos/170811/pexels-photo-170811.jpeg?auto=compress&cs=tinysrgb&h=350' });
            }, getMessage: function () { return 'Drop files here'; }, onFilesSelect: this.onFilesSelect, getFiles: this.getFiles });
    };
    VueMultiFileField = __decorate([
        vue_index_1.ComponentName('vue-multi-file-field'),
        vue_property_decorator_1.Component,
        __metadata("design:paramtypes", [])
    ], VueMultiFileField);
    return VueMultiFileField;
}(vue_base_filefield_component_1.VueBaseFileField));
//# sourceMappingURL=vue-multi-filefield.component.js.map