"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var redux_effects_promise_1 = require("redux-effects-promise");
var util_1 = require("../../util");
var filter_interface_1 = require("./filter.interface");
var FilterActionBuilder = /** @class */ (function () {
    function FilterActionBuilder() {
    }
    FilterActionBuilder.buildManualApplyActionType = function (section) {
        return section + "." + filter_interface_1.FILTER_MANUAL_APPLY_ACTION_TYPE;
    };
    /**
     * @stable [26.08.2018]
     * @param {string} section
     * @returns {string}
     */
    FilterActionBuilder.buildRefreshActionType = function (section) {
        return util_1.toActionPrefix(section) + "." + filter_interface_1.FILTER_REFRESH_ACTION_TYPE;
    };
    FilterActionBuilder.buildApplyActionType = function (section) {
        return section + "." + filter_interface_1.FILTER_APPLY_ACTION_TYPE;
    };
    FilterActionBuilder.buildOpenActionType = function (section) {
        return section + "." + filter_interface_1.FILTER_OPEN_ACTION_TYPE;
    };
    FilterActionBuilder.buildDeactivateActionType = function (section) {
        return section + "." + filter_interface_1.FILTER_DEACTIVATE_ACTION_TYPE;
    };
    FilterActionBuilder.buildActivateActionType = function (section) {
        return section + "." + filter_interface_1.FILTER_ACTIVATE_ACTION_TYPE;
    };
    FilterActionBuilder.buildDestroyActionType = function (section) {
        return section + "." + filter_interface_1.FILTER_DESTROY_ACTION_TYPE;
    };
    FilterActionBuilder.buildChangeActionType = function (section) {
        return section + "." + filter_interface_1.FILTER_CHANGE_ACTION_TYPE;
    };
    FilterActionBuilder.buildChangeAction = function (section, queryWrapper) {
        return redux_effects_promise_1.EffectsAction.create(this.buildChangeActionType(section), util_1.applySection(section, queryWrapper));
    };
    FilterActionBuilder.buildDestroyAction = function (section) {
        return redux_effects_promise_1.EffectsAction.create(this.buildDestroyActionType(section), util_1.applySection(section));
    };
    FilterActionBuilder.buildActivateAction = function (section) {
        return redux_effects_promise_1.EffectsAction.create(this.buildActivateActionType(section), util_1.applySection(section));
    };
    FilterActionBuilder.buildManualApplyAction = function (section, queryWrapper) {
        return redux_effects_promise_1.EffectsAction.create(this.buildManualApplyActionType(section), util_1.applySection(section, queryWrapper));
    };
    return FilterActionBuilder;
}());
exports.FilterActionBuilder = FilterActionBuilder;
//# sourceMappingURL=filter-action.builder.js.map