"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var util_1 = require("../../util");
var field_1 = require("../field");
var header_1 = require("./header");
var column_1 = require("./column");
var list_1 = require("../list");
var row_1 = require("./row");
var field_2 = require("../field");
var layout_1 = require("../layout");
var Grid = /** @class */ (function (_super) {
    __extends(Grid, _super);
    /**
     * @stable [07.06.2018]
     * @param {IGridProps} props
     */
    function Grid(props) {
        var _this = _super.call(this, props) || this;
        _this.onHeaderColumnClick = _this.onHeaderColumnClick.bind(_this);
        _this.onSettingsClick = _this.onSettingsClick.bind(_this);
        _this.onPlusClick = _this.onPlusClick.bind(_this);
        _this.state = { filterChanges: {}, expandedGroups: {} };
        return _this;
    }
    /**
     * @stable [09.09.2018]
     * @returns {JSX.Element}
     */
    Grid.prototype.getView = function () {
        var _this = this;
        var props = this.props;
        var dataSource = this.dataSource;
        var gridEl = (React.createElement(layout_1.FlexLayout, { row: true, className: 'rac-grid-wrapper' },
            React.createElement("table", { cellPadding: 0, cellSpacing: 0, className: util_1.toClassName('rac-grid', 'rac-flex', 'rac-flex-column', props.tightGrid && 'rac-tight-grid', props.className) },
                React.createElement("thead", { className: 'rac-grid-head' },
                    this.headerElement,
                    this.filterElement),
                React.createElement("tbody", { ref: 'container', className: 'rac-grid-body' }, util_1.orDefault(util_1.isDef(props.groupBy), function () { return _this.getGroupedRows(dataSource); }, function () { return dataSource.map(function (entity, index) { return _this.getRow(entity, index); }); }))),
            this.addActionElement));
        if (!props.useService) {
            return gridEl;
        }
        return (React.createElement(layout_1.FlexLayout, { row: true },
            gridEl,
            React.createElement("div", { className: 'rac-grid-service-wrapper' },
                React.createElement("div", { className: 'rac-grid-service' }, util_1.orNull(props.useService, function () { return _this.uiFactory.makeIcon({ type: 'more_vert', onClick: _this.onSettingsClick }); })))));
    };
    /**
     * @stable [07.06.2018]
     * @returns {IEntity[]}
     */
    Grid.prototype.filterAndSortOriginalDataSourceUsingLocalFiltersAndSorters = function () {
        var props = this.props;
        var state = this.state;
        var source = this.originalDataSource;
        if (!R.isNil(source)) {
            if (props.useLocalFiltering) {
                var filterChanges_1 = state.filterChanges;
                var columns_1 = this.columnsConfiguration;
                var changedColumns_1 = Object.keys(filterChanges_1);
                var defaultLocalFilter_1 = function (cfg) {
                    return util_1.queryFilter(cfg.query, cfg.entity[cfg.columnName]);
                };
                if (changedColumns_1.length > 0) {
                    return source.filter(function (entity) {
                        var result = true;
                        changedColumns_1.forEach(function (columnName) {
                            var query = filterChanges_1[columnName];
                            var column = columns_1.find(function (column0) { return column0.name === columnName; });
                            result = result && (util_1.isFn(column.localFilter) ? column.localFilter : defaultLocalFilter_1)({ query: query, columnName: columnName, entity: entity });
                        });
                        return result;
                    });
                }
            }
        }
        return source;
    };
    Grid.prototype.onSettingsClick = function () {
        // TODO
    };
    /**
     * @stable [12.08.2018]
     */
    Grid.prototype.onPlusClick = function () {
        var props = this.props;
        if (props.onPlusClick) {
            props.onPlusClick();
        }
    };
    /**
     * @stable - 05.04.2018
     * @param {ISortDirectionEntity} payload
     */
    Grid.prototype.onHeaderColumnClick = function (payload) {
        var props = this.props;
        if (props.onChangeSorting) {
            props.onChangeSorting(payload);
        }
    };
    /**
     * @stable [06.06.2018]
     * @param {IFieldChangeEntity} payload
     */
    Grid.prototype.onChangeRowField = function (payload) {
        var props = this.props;
        if (props.onChange) {
            props.onChange(payload);
        }
    };
    /**
     * @stable [07.06.2018]
     * @param {IFieldChangeEntity} payload
     */
    Grid.prototype.onChangeGroupingRowField = function (payload) {
        var props = this.props;
        if (props.onChangeGrouping) {
            props.onChangeGrouping(payload);
        }
    };
    /**
     * @stable [07.06.2018]
     * @param {IFieldChangeEntity} payload
     */
    Grid.prototype.onChangeHeaderField = function (payload) {
        var props = this.props;
        if (props.onChangeHeader) {
            props.onChangeHeader(payload);
        }
    };
    /**
     * @stable [07.06.2018]
     * @param {IFieldChangeEntity} payload
     */
    Grid.prototype.onChangeFilterField = function (payload) {
        var _a;
        var props = this.props;
        if (props.useLocalFiltering) {
            this.setState({
                filterChanges: __assign({}, this.state.filterChanges, (_a = {}, _a[payload.name] = payload.value, _a)),
            });
        }
        else if (props.onChangeFilter) {
            props.onChangeFilter(payload);
        }
    };
    /**
     * @stable - 06.04.2018
     * @param {IGridColumnConfiguration} column
     * @param {number} columnNum
     * @returns {React.ReactNode}
     */
    Grid.prototype.getHeaderColumn = function (column, columnNum) {
        var _this = this;
        if (column.useGrouping) {
            var name_1 = this.toHeaderFieldName(columnNum);
            return (React.createElement(field_1.Checkbox, __assign({}, this.getDefaultFieldProps(), { name: name_1, value: this.toCheckboxFieldValue(name_1), onChange: function (value) { return _this.onChangeHeaderField({ value: value, name: name_1 }); } })));
        }
        else if (column.headerRenderer) {
            return column.headerRenderer(column);
        }
        return this.t(column.title);
    };
    Object.defineProperty(Grid.prototype, "headerElement", {
        /**
         * @stable - 06.04.2018
         * @returns {JSX.Element}
         */
        get: function () {
            var _this = this;
            var props = this.props;
            return (React.createElement(row_1.GridRow, { className: 'rac-grid-header' }, this.columnsConfiguration.map(function (column, columnNum) {
                var headerColumnName = _this.toHeaderColumnKey(columnNum);
                return (React.createElement(header_1.GridHeaderColumn, __assign({ key: headerColumnName, name: headerColumnName, index: columnNum, direction: props.directions[headerColumnName], onClick: _this.onHeaderColumnClick }, column), _this.getHeaderColumn(column, columnNum)));
            })));
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [07.06.2018]
     * @param {IEntity} entity
     * @param {IGridColumnConfiguration} column
     * @param {number} columnNum
     * @returns {React.ReactNode}
     */
    Grid.prototype.getColumn = function (entity, column, columnNum) {
        var _this = this;
        var name = this.toFieldName(entity, column, columnNum);
        if (column.useGrouping) {
            return (
            /**
             * Default group field
             */
            React.createElement(field_1.Checkbox, __assign({}, this.getDefaultFieldProps(), { name: name, value: this.toCheckboxFieldValue(name), onChange: function (value) { return _this.onChangeGroupingRowField({ value: value, name: name, rawData: entity }); } })));
        }
        else if (column.tpl) {
            /**
             * Build using a text template
             */
            return column.tpl(entity);
        }
        else if (column.renderer) {
            /**
             * Build using a renderer
             */
            var renderEl = column.renderer(entity, column);
            if (R.isNil(renderEl)) {
                return renderEl;
            }
            if (this.isElementField(renderEl)) {
                return React.cloneElement(renderEl, __assign({}, this.getDefaultFieldProps(), { name: column.name, value: util_1.isDef(renderEl.props.value) ? renderEl.props.value : Reflect.get(entity, column.name), onChange: function (value) { return _this.onChangeRowField({ value: value, name: name, rawData: entity }); } }));
            }
            return renderEl;
        }
        else if (column.name) {
            /**
             * Build by a column name
             */
            return Reflect.get(entity, column.name);
        }
        return null;
    };
    /**
     * @stable [07.06.2018]
     * @param {IGridColumnConfiguration} column
     * @param {number} columnNum
     * @returns {React.ReactNode}
     */
    Grid.prototype.getFilterColumn = function (column, columnNum) {
        var _this = this;
        if (column.filterRenderer) {
            /**
             * Build using a renderer
             */
            var renderEl = column.filterRenderer(column);
            if (R.isNil(renderEl)) {
                return renderEl;
            }
            if (this.isElementField(renderEl)) {
                var name_2 = this.toFilterFieldName(column, columnNum);
                return React.cloneElement(renderEl, __assign({}, this.getDefaultFieldProps(), { value: this.toFilterFieldValue(name_2), placeholder: 'Filter', clearActionRendered: true, onChange: function (value) { return _this.onChangeFilterField({ value: value, name: name_2 }); } }));
            }
            return renderEl;
        }
        return null;
    };
    /**
     * @stable - 05.04.2018
     * @param {IEntity} entity
     * @param {number} index
     * @param {boolean} needToApplyOddClassName
     * @returns {JSX.Element}
     */
    Grid.prototype.getRow = function (entity, index, needToApplyOddClassName) {
        var _this = this;
        if (needToApplyOddClassName === void 0) { needToApplyOddClassName = true; }
        var props = this.props;
        var rowKey = this.toRowKey(entity);
        var changes = props.changes;
        var entityChanges = changes[entity.id];
        return (React.createElement(row_1.GridRow, { ref: rowKey, key: rowKey, className: util_1.toClassName('rac-grid-data-row', util_1.orUndef(props.applyOdd !== false && needToApplyOddClassName && util_1.isOddNumber(index), 'rac-grid-data-row-odd'), util_1.orUndef(props.hovered !== false, 'rac-grid-data-row-hovered'), util_1.orUndef(props.selectable !== false, 'rac-grid-data-row-selectable')), selected: this.isEntitySelected(entity), onClick: function () { return _this.onSelect(entity); } }, this.columnsConfiguration.map(function (column, columnNum) { return (React.createElement(column_1.GridColumn, __assign({ key: rowKey + "-" + columnNum, index: columnNum, className: util_1.toClassName(!R.isNil(entityChanges) && util_1.isDef(entityChanges[column.name]) && 'rac-grid-column-edited'), entity: entity }, column), _this.getColumn(entity, column, columnNum))); })));
    };
    Object.defineProperty(Grid.prototype, "filterElement", {
        /**
         * @stable - 05.04.2018
         * @returns {JSX.Element}
         */
        get: function () {
            var _this = this;
            var columns = this.columnsConfiguration;
            var isAtLeastOneFilterExist = columns
                .filter(function (column) { return !R.isNil(column.filterRenderer); }).length > 0;
            return (util_1.orNull(isAtLeastOneFilterExist, function () { return (React.createElement(row_1.GridRow, { className: 'rac-grid-filter-row' }, columns.map(function (column, columnNum) { return (React.createElement(header_1.GridHeaderColumn, __assign({ key: _this.toFilterColumnKey(columnNum), index: columnNum }, column), _this.getFilterColumn(column, columnNum))); }))); }));
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [07.06.2018]
     * @param {string} name
     * @returns {AnyT}
     */
    Grid.prototype.toFilterFieldValue = function (name) {
        var props = this.props;
        var state = this.state;
        return util_1.orUndef(props.useLocalFiltering, function () { return state.filterChanges[name]; });
    };
    /**
     * @stable [07.06.2018]
     * @returns {IFieldProps}
     */
    Grid.prototype.getDefaultFieldProps = function () {
        return {
            errorMessageRendered: false,
            readOnly: this.props.deactivated,
        };
    };
    /**
     * @stable [07.06.2018]
     * @param {IEntity} entity
     * @param {IGridColumnConfiguration} column
     * @param {number} columnNum
     * @returns {string}
     */
    Grid.prototype.toFieldName = function (entity, column, columnNum) {
        return column.name || "$$dynamic-field-" + entity.id + "-" + columnNum; // Infinity scroll supporting
    };
    /**
     * @stable [07.06.2018]
     * @param {IGridColumnConfiguration} column
     * @param {number} columnNum
     * @returns {string}
     */
    Grid.prototype.toFilterFieldName = function (column, columnNum) {
        return column.name || "$$dynamic-filter-field-" + columnNum;
    };
    /**
     * @stable - 06.04.2018
     * @param {number} columnNum
     * @returns {string}
     */
    Grid.prototype.toHeaderFieldName = function (columnNum) {
        return "$$dynamic-header-field-" + columnNum;
    };
    /**
     * @stable - 05.04.2018
     * @param {number} columnNum
     * @returns {string}
     */
    Grid.prototype.toFilterColumnKey = function (columnNum) {
        return "grid-filter-column-" + columnNum;
    };
    /**
     * @stable - 05.04.2018
     * @param {number} columnNum
     * @returns {string}
     */
    Grid.prototype.toHeaderColumnKey = function (columnNum) {
        return "grid-header-column-" + columnNum;
    };
    /**
     * @stable - 06.04.2018
     * @param {string} fieldName
     * @returns {AnyT}
     */
    Grid.prototype.toFieldValue = function (fieldName) {
        return this.props.changes[fieldName];
    };
    /**
     * @stable - 06.04.2018
     * @param {string} fieldName
     * @returns {AnyT}
     */
    Grid.prototype.toCheckboxFieldValue = function (fieldName) {
        var fieldValue = this.toFieldValue(fieldName);
        return util_1.isDef(fieldValue) ? fieldValue : false;
    };
    /**
     * @stable [07.06.2018]
     * @param {JSX.Element} renderEl
     * @returns {boolean}
     */
    Grid.prototype.isElementField = function (renderEl) {
        return field_2.Field.isPrototypeOf(renderEl.type);
    };
    Object.defineProperty(Grid.prototype, "columnsConfiguration", {
        /**
         * @stable [10.10.2018]
         * @returns {IGridColumnConfiguration[]}
         */
        get: function () {
            return R.filter(function (column) { return column.rendered !== false; }, this.props.columnsConfiguration);
        },
        enumerable: true,
        configurable: true
    });
    /**
     * @stable [04.07.2018]
     * @param {EntityIdT} groupedRowValue
     * @returns {string}
     */
    Grid.prototype.toGroupedRowKey = function (groupedRowValue) {
        return "data-grouped-row-" + groupedRowValue;
    };
    /**
     * @stable [05.10.2018]
     * @param {EntityIdT} groupedRowValue
     * @param {number} columnNum
     * @returns {string}
     */
    Grid.prototype.toGroupedColumnKey = function (groupedRowValue, columnNum) {
        return "data-grouped-column-" + groupedRowValue + "-" + columnNum;
    };
    /**
     * @stable [06.09.2018]
     * @param {IEntity[]} dataSource
     * @returns {JSX.Element[]}
     */
    Grid.prototype.getGroupedRows = function (dataSource) {
        var _this = this;
        if (R.isEmpty(dataSource)) {
            return [];
        }
        var groupBy = this.props.groupBy;
        var currentGroupedEntities = [];
        var rows = [];
        var currentGroupColumnValue;
        dataSource.forEach(function (entity) {
            var groupColumnValue = Reflect.get(entity, groupBy.columnName);
            if (!R.equals(currentGroupColumnValue, groupColumnValue)
                && !R.isNil(currentGroupColumnValue)) {
                rows = _this.buildRowsGroup(rows, currentGroupColumnValue, currentGroupedEntities);
                currentGroupedEntities.length = 0;
            }
            currentGroupColumnValue = groupColumnValue;
            currentGroupedEntities.push(entity);
        });
        if (currentGroupedEntities.length) {
            rows = this.buildRowsGroup(rows, currentGroupColumnValue, currentGroupedEntities);
        }
        return rows;
    };
    /**
     * @stable [06.09.2018]
     * @param {JSX.Element[]} rows
     * @param {EntityIdT} currentGroupColumnValue
     * @param {IEntity[]} currentGroupedEntities
     * @returns {JSX.Element[]}
     */
    Grid.prototype.buildRowsGroup = function (rows, currentGroupColumnValue, currentGroupedEntities) {
        var _this = this;
        rows = rows.concat(this.getGroupingRow(currentGroupColumnValue, currentGroupedEntities));
        if (this.isGroupedRowExpanded(currentGroupColumnValue)) {
            var needToApplyOddClassName_1 = currentGroupedEntities.length > 1;
            return rows.concat(currentGroupedEntities.map(function (entity0, index) { return _this.getRow(entity0, index, needToApplyOddClassName_1); }));
        }
        return rows;
    };
    /**
     * @stable [04.07.2018]
     * @param {EntityIdT} groupedRowValue
     * @param {IEntity[]} groupedRows
     * @returns {JSX.Element}
     */
    Grid.prototype.getGroupingRow = function (groupedRowValue, groupedRows) {
        var _this = this;
        var props = this.props;
        var groupBy = props.groupBy;
        var isExpanded = this.isGroupedRowExpanded(groupedRowValue);
        var columns = this.columnsConfiguration;
        return (React.createElement(row_1.GridRow, { key: this.toGroupedRowKey(groupedRowValue), className: util_1.toClassName('rac-grid-data-row', 'rac-grid-data-row-grouped', isExpanded && 'rac-grid-data-row-group-expanded') }, columns.map(function (column, columnNum) { return (React.createElement(column_1.GridColumn, __assign({ key: _this.toGroupedColumnKey(groupedRowValue, columnNum) }, column), util_1.orDefault(columnNum === 0, function () { return ([
            React.createElement(layout_1.FlexLayout, { row: true, key: _this.toGroupedColumnKey(groupedRowValue + "-content", columnNum) },
                util_1.orNull(props.expandActionRendered !== false, function () { return (_this.uiFactory.makeIcon({
                    className: 'rac-grid-data-row-group-expanded-icon',
                    type: isExpanded ? 'minus_square' : 'plus_square',
                    onClick: function (event) { return _this.onExpandGroup(event, groupedRowValue, !isExpanded); },
                })); }),
                " ",
                util_1.isFn(groupBy.groupValue)
                    ? groupBy.groupValue(groupedRowValue, groupedRows)
                    : (Array.isArray(groupBy.groupValue)
                        ? (util_1.isFn(groupBy.groupValue[0]) ? groupBy.groupValue[0](groupedRowValue, groupedRows) : null)
                        : groupedRowValue))
        ]); }, function () { return util_1.orNull(Array.isArray(groupBy.groupValue) && util_1.isFn(groupBy.groupValue[columnNum]), function () { return groupBy.groupValue[columnNum](groupedRowValue, groupedRows); }); }))); })));
    };
    /**
     * @stable [04.07.2018]
     * @param {IBasicEvent} event
     * @param {EntityIdT} groupedRowValue
     * @param {boolean} expanded
     */
    Grid.prototype.onExpandGroup = function (event, groupedRowValue, expanded) {
        var _a;
        util_1.cancelEvent(event);
        this.setState({ expandedGroups: __assign({}, this.state.expandedGroups, (_a = {}, _a[groupedRowValue] = expanded, _a)) });
    };
    /**
     * @stable [03.09.2018]
     * @param {EntityIdT} groupedRowValue
     * @returns {boolean}
     */
    Grid.prototype.isGroupedRowExpanded = function (groupedRowValue) {
        var state = this.state;
        var props = this.props;
        return util_1.coalesce(!R.isNil(state.expandedGroups) && Reflect.get(state.expandedGroups, groupedRowValue), !R.isNil(props.expandedGroups) && Reflect.get(props.expandedGroups, groupedRowValue), false);
    };
    return Grid;
}(list_1.BaseList));
exports.Grid = Grid;
//# sourceMappingURL=grid.component.js.map