"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @stable [08.05.2018]
 */
var KeyboardKeyEnum;
(function (KeyboardKeyEnum) {
    KeyboardKeyEnum[KeyboardKeyEnum["UPPERCASE"] = 0] = "UPPERCASE";
    KeyboardKeyEnum[KeyboardKeyEnum["CHANGE_LAYOUT"] = 1] = "CHANGE_LAYOUT";
    KeyboardKeyEnum[KeyboardKeyEnum["LOWERCASE"] = 2] = "LOWERCASE";
    KeyboardKeyEnum[KeyboardKeyEnum["BACKSPACE"] = 3] = "BACKSPACE";
    KeyboardKeyEnum[KeyboardKeyEnum["SPACE"] = 4] = "SPACE";
    KeyboardKeyEnum[KeyboardKeyEnum["ENTER"] = 5] = "ENTER";
})(KeyboardKeyEnum = exports.KeyboardKeyEnum || (exports.KeyboardKeyEnum = {}));
/**
 * @stable [08.05.2018]
 */
exports.KEYBOARD_SPECIAL_KEYS = {
    UPPERCASE: '↑',
    LOWERCASE: '↓',
    BACK: '‹',
    SPACE: ' ',
    DIGITAL: '123',
    LITERAL: 'ABC',
};
/**
 * @stable [08.05.2018]
 */
exports.KEYBOARD_QWERTY_LAYOUT = [
    ['q', 'w', 'e', 'r', 't', 'y', 'u', 'i', 'o', 'p'],
    ['a', 's', 'd', 'f', 'g', 'h', 'j', 'k', 'l'],
    [{ value: exports.KEYBOARD_SPECIAL_KEYS.UPPERCASE, type: KeyboardKeyEnum.UPPERCASE },
        'z', 'x', 'c', 'v', 'b', 'n', 'm',
        { value: exports.KEYBOARD_SPECIAL_KEYS.BACK, type: KeyboardKeyEnum.BACKSPACE }],
    [
        { value: exports.KEYBOARD_SPECIAL_KEYS.DIGITAL, type: KeyboardKeyEnum.CHANGE_LAYOUT, className: 'rac-keyboard-digital' },
        ',',
        { value: exports.KEYBOARD_SPECIAL_KEYS.SPACE, type: KeyboardKeyEnum.SPACE, width: 200 },
        '.'
    ]
];
/**
 * @stable [08.05.2018]
 */
exports.KEYBOARD_QWERTY_DIGITAL_LAYOUT = [
    ['1', '2', '3', '4', '5', '6', '7', '8', '9', '0'],
    ['!', '@', '#', '$', '%', '&', '+', '?', '/'],
    ['*', '_', '"', '\'', '(', ')', '-', ':', { value: exports.KEYBOARD_SPECIAL_KEYS.BACK, type: KeyboardKeyEnum.BACKSPACE }],
    [{ value: exports.KEYBOARD_SPECIAL_KEYS.LITERAL, type: KeyboardKeyEnum.CHANGE_LAYOUT, className: 'rac-keyboard-digital' },
        ';', ',', { value: exports.KEYBOARD_SPECIAL_KEYS.SPACE, type: KeyboardKeyEnum.SPACE, width: 200 }, '.', '=']
];
/**
 * @stable [21.11.2018]
 */
exports.KEYBOARD_NUMERIC_LAYOUT = [
    ['1', '2', '3', '4', '5'],
    ['6', '7', '8', '9', '0'],
    ['+', '-', ',', '.', { value: exports.KEYBOARD_SPECIAL_KEYS.BACK, type: KeyboardKeyEnum.BACKSPACE }]
];
//# sourceMappingURL=keyboard.interface.js.map