import { IKeyValue, AnyT } from '../../../definitions.interface';
import { IUniversalLayoutBuilderConfiguration, UniversalLayoutBuilderChildrenT } from '../../../configurations-definitions.interface';
import { UniversalLayoutViewBuilder } from './universal-layout-view.builder';
export declare class DefaultLayoutViewBuilder<TNode> extends UniversalLayoutViewBuilder<TNode> {
    /**
     * @stable [22.10.2018]
     * @param {IKeyValue} props
     * @param {Array<UniversalLayoutBuilderChildrenT<TNode>>} children
     * @param {IUniversalLayoutBuilderConfiguration<TNode>} layoutConfig
     * @returns {AnyT}
     */
    buildRowView(props: IKeyValue, children: Array<UniversalLayoutBuilderChildrenT<TNode>>, layoutConfig: IUniversalLayoutBuilderConfiguration<TNode>): AnyT;
    /**
     * @stable [22.10.2018]
     * @param {IKeyValue} props
     * @param {Array<UniversalLayoutBuilderChildrenT<TNode>>} children
     * @param {IUniversalLayoutBuilderConfiguration<TNode>} layoutConfig
     * @returns {AnyT}
     */
    buildColumnView(props: IKeyValue, children: Array<UniversalLayoutBuilderChildrenT<TNode>>, layoutConfig: IUniversalLayoutBuilderConfiguration<TNode>): AnyT;
    /**
     * @stable [22.10.2018]
     * @param {IKeyValue} props
     * @returns {AnyT}
     */
    buildSeparatorView(props: IKeyValue): AnyT;
    /**
     * @stable [22.10.2018]
     * @param {UniversalLayoutBuilderChildrenT<TNode>} item
     * @returns {boolean}
     */
    isClonedItem(item: UniversalLayoutBuilderChildrenT<TNode>): boolean;
}
