import { IUniversalLayoutBuilderConfiguration, UniversalLayoutBuilderChildrenT } from '../../../configurations-definitions.interface';
import { ILayoutViewBuilder } from './layout-builder.interface';
export declare class UniversalLayoutBuilder<TNode> {
    private layoutViewBuilder;
    private index;
    private layoutId;
    /**
     * @stable [22.10.2018]
     * @param {ILayoutViewBuilder<TNode>} layoutViewBuilder
     */
    constructor(layoutViewBuilder: ILayoutViewBuilder<TNode>);
    /**
     * @stable [22.10.2018]
     * @param {IUniversalLayoutBuilderConfiguration<TNode>} layoutConfig
     * @returns {TNode}
     */
    build(layoutConfig: IUniversalLayoutBuilderConfiguration<TNode>): TNode;
    /**
     * @stable [22.10.2018]
     * @param {UniversalLayoutBuilderChildrenT<TNode>} item
     * @returns {string}
     */
    protected getClonedItemKey(item: UniversalLayoutBuilderChildrenT<TNode>): string;
    /**
     * @stable [22.10.2018]
     * @param {IUniversalLayoutBuilderConfiguration<TNode>} layoutConfig
     * @returns {TNode}
     */
    private buildLayout;
    /**
     * @stable [22.10.2018]
     * @param {IUniversalLayoutBuilderConfiguration<TNode>} layoutConfig
     * @returns {TNode}
     */
    private buildHorizontalLayout;
    /**
     * @stable [22.10.2018]
     * @param {IUniversalLayoutBuilderConfiguration<TNode>} layoutConfig
     * @returns {TNode}
     */
    private buildVerticalLayout;
    /**
     * @stable [22.10.2018]
     * @param {IUniversalLayoutBuilderConfiguration<TNode>} layoutConfig
     * @returns {Array<UniversalLayoutBuilderChildrenT<TNode>>}
     */
    private getDefinedChildren;
    /**
     * @stable [22.10.2018]
     * @param {UniversalLayoutBuilderChildrenT<TNode>} item
     * @param {IUniversalLayoutBuilderConfiguration<TNode>} layoutConfig
     * @returns {TNode}
     */
    private tryCloneItem;
    /**
     * @stable [22.10.2018]
     * @returns {{key: string}}
     */
    private readonly key;
    /**
     * @stable [22.10.2018]
     * @returns {string}
     */
    private readonly newKey;
}
