/// <reference types="react" />
import { BaseComponent } from '../../base';
import { INavigationListProps } from './navigation-list.interface';
export declare class NavigationList extends BaseComponent<NavigationList, INavigationListProps> {
    /**
     * @stable [11.08.2018]
     * @param {INavigationListProps} props
     */
    constructor(props: INavigationListProps);
    /**
     * @stable [23.09.2018]
     * @returns {JSX.Element}
     */
    render(): JSX.Element;
    /**
     * @stable [23.09.2018]
     * @param {INavigationListItemConfiguration} item
     * @returns {JSX.Element}
     */
    private toElement;
    /**
     * @stable [23.09.2018]
     * @param {INavigationListItemConfiguration} config
     */
    private onGroupLinkClick;
    /**
     * @stable [23.09.2018]
     * @param {string} link
     * @param {string} prefix
     * @returns {string}
     */
    private toUniqueKey;
    /**
     * @stable [23.09.2018]
     * @param {INavigationListItemConfiguration} item
     * @returns {boolean}
     */
    private isItemExpanded;
    /**
     * @stable [23.09.2018]
     * @returns {boolean}
     */
    private readonly fullLayoutModeEnabled;
    /**
     * @stable [23.09.2018]
     * @param {INavigationListItemConfiguration} item
     * @returns {boolean}
     */
    private hasActiveChild;
}
