"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var R = require("ramda");
var util_1 = require("../../../util");
var universal_page_toolbar_component_1 = require("./universal-page-toolbar.component");
var layout_1 = require("../../layout");
var PageToolbar = /** @class */ (function (_super) {
    __extends(PageToolbar, _super);
    function PageToolbar() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    /**
     * @stable [16.05.2018]
     * @returns {JSX.Element}
     */
    PageToolbar.prototype.render = function () {
        var _this = this;
        var props = this.props;
        return util_1.orNull(this.isToolbarVisible(), function () { return (React.createElement(layout_1.FlexLayout, { className: util_1.toClassName('rac-toolbar', 'rac-page-toolbar', props.className) }, _this.getToolbarBody())); });
    };
    /**
     * @stable [25.06.2018]
     * @returns {JSX.Element}
     */
    PageToolbar.prototype.getContent = function () {
        var _this = this;
        var controls = this.checkAndGetControls();
        return util_1.orNull(!(R.isNil(this.props.children) && R.isNil(controls)), function () { return (React.createElement(layout_1.FlexLayout, { alignItemsCenter: true, row: true, className: 'rac-toolbar-content' },
            _this.getLeftContent(),
            controls,
            _this.getRightContent())); });
    };
    /**
     * @stable [25.06.2018]
     * @returns {JSX.Element}
     */
    PageToolbar.prototype.getRightContent = function () {
        return React.createElement(layout_1.FlexLayout, null);
    };
    /**
     * @stable [16.05.2018]
     * @returns {JSX.Element}
     */
    PageToolbar.prototype.getLeftContent = function () {
        return (React.createElement(layout_1.FlexLayout, { row: true }, this.props.children));
    };
    /**
     * @stable [25.06.2018]
     * @returns {JSX.Element}
     */
    PageToolbar.prototype.getPagesElement = function () {
        return (React.createElement(layout_1.FlexLayout, { alignItemsCenter: true, justifyContentCenter: true, className: 'rac-toolbar-pages-info' }, this.pagesInfoLabel));
    };
    /**
     * @stable [16.05.2018]
     * @returns {JSX.Element}
     */
    PageToolbar.prototype.getControls = function () {
        var props = this.props;
        var isPreviousBtnDisabled = this.isPreviousBtnDisabled;
        var isNextBtnDisabled = this.isNextBtnDisabled;
        return (React.createElement(layout_1.FlexLayout, { row: true, full: false },
            this.uiFactory.makeIcon({
                type: 'first_page',
                className: 'rac-button-page-icon',
                disabled: isPreviousBtnDisabled,
                onClick: props.onFirst,
            }),
            this.uiFactory.makeIcon({
                type: 'keyboard_arrow_left',
                className: 'rac-button-page-icon',
                disabled: isPreviousBtnDisabled,
                onClick: props.onPrevious,
            }),
            this.getPagesElement(),
            this.uiFactory.makeIcon({
                type: 'keyboard_arrow_right',
                className: 'rac-button-page-icon',
                disabled: isNextBtnDisabled,
                onClick: props.onNext,
            }),
            this.uiFactory.makeIcon({
                type: 'last_page',
                className: 'rac-button-page-icon',
                disabled: isNextBtnDisabled,
                onClick: props.onLast,
            })));
    };
    return PageToolbar;
}(universal_page_toolbar_component_1.UniversalPageToolbar));
exports.PageToolbar = PageToolbar;
//# sourceMappingURL=page-toolbar.component.js.map