"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var cropperjs_1 = require("cropperjs");
var vue_property_decorator_1 = require("vue-property-decorator");
var util_1 = require("../../../util");
var vue_index_1 = require("../../connector/vue-index");
var vue_viewer_interface_1 = require("../vue-viewer.interface");
var vue_index_2 = require("../picture/vue-index");
var vue_cropper_viewer_interface_1 = require("./vue-cropper-viewer.interface");
var VueCropperViewer = /** @class */ (function (_super) {
    __extends(VueCropperViewer, _super);
    function VueCropperViewer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.cropEmitterTask = new util_1.DelayedTask(_this.onCrop, 100);
        return _this;
    }
    /**
     * @stable [29.11.2018]
     * @param {VueCreateElementFactoryT} createElement
     * @returns {VueNodeT}
     */
    VueCropperViewer.prototype.render = function (createElement) {
        return _super.prototype.render.call(this, createElement);
    };
    /**
     * @stable [29.11.2018]
     */
    VueCropperViewer.prototype.beforeDestroy = function () {
        this.cropEmitterTask.stop();
        if (util_1.isDef(this.cropper)) {
            this.cropper.destroy();
            this.cropper = null;
        }
    };
    /**
     * @stable [29.11.2018]
     */
    VueCropperViewer.prototype.onOpenPopup = function () {
        _super.prototype.onOpenPopup.call(this);
    };
    /**
     * @stable [29.11.2018]
     */
    VueCropperViewer.prototype.onClosePopup = function () {
        _super.prototype.onClosePopup.call(this);
    };
    // TODO
    VueCropperViewer.prototype.getPopupHeaderTemplate = function () {
        return "\n      <vue-button @click=\"onApply\"\n                  text=\"Apply\"/>\n      <vue-button @click=\"onRemove\"\n                  text=\"Remove\"/>\n    ";
    };
    /**
     * @stable [29.11.2018]
     * @returns {IVueCropperPictureViewerTemplateMethodsEntity}
     */
    VueCropperViewer.prototype.getTemplateMethods = function () {
        return __assign({}, _super.prototype.getTemplateMethods.call(this), { onApply: this.onApply, onRemove: this.onRemove });
    };
    /**
     * @stable [29.11.2018]
     */
    VueCropperViewer.prototype.onAfterOpenPopup = function () {
        var _this = this;
        _super.prototype.onAfterOpenPopup.call(this);
        this.cropper = new cropperjs_1.default(this.getSelf(), {
            crop: function () { return _this.cropEmitterTask.start(); },
        });
    };
    /**
     * @stable [29.11.2018]
     */
    VueCropperViewer.prototype.onApply = function () {
        var _this = this;
        this.getCroppedCanvasBlob(function (blob) {
            _this.onClosePopup();
            _this.$nextTick(function () { return _this.$emit(vue_viewer_interface_1.VUE_VIEWER_CHANGE_EVENT, blob); });
        });
    };
    /**
     * @stable [29.11.2018]
     */
    VueCropperViewer.prototype.onRemove = function () {
        var _this = this;
        this.onClosePopup();
        this.$nextTick(function () { return _this.$emit(vue_cropper_viewer_interface_1.VUE_CROPPER_VIEWER_REMOVE_EVENT); });
    };
    /**
     * @stable [29.11.2018]
     */
    VueCropperViewer.prototype.onCrop = function () {
        var _this = this;
        this.getCroppedCanvasBlob(function (blob) { return _this.$emit(vue_cropper_viewer_interface_1.VUE_CROPPER_VIEWER_CROP_EVENT, blob); });
    };
    /**
     * @stable [29.11.2018]
     * @param {(blob: Blob) => void} callback
     */
    VueCropperViewer.prototype.getCroppedCanvasBlob = function (callback) {
        this.cropper.getCroppedCanvas().toBlob(callback);
    };
    VueCropperViewer = __decorate([
        vue_index_1.ComponentName('vue-cropper-viewer'),
        vue_property_decorator_1.Component({
            data: function () {
                var self = this;
                return self.getInitialData$();
            },
        })
    ], VueCropperViewer);
    return VueCropperViewer;
}(vue_index_2.VueBasePictureViewer));
//# sourceMappingURL=vue-cropper-viewer.component.js.map