/// <reference types="react" />
import { IPdfViewerProps, IPdfViewerState } from './pdf-viewer.interface';
import { Viewer } from '../viewer.component';
export declare class PdfViewer extends Viewer<PdfViewer, IPdfViewerProps, IPdfViewerState> {
    static defaultProps: IPdfViewerProps;
    private static PREVIEW_WIDTH;
    private pdfRendererPlugin;
    /**
     * @stable [08.07.2018]
     * @param {IPdfViewerProps} props
     */
    constructor(props: IPdfViewerProps);
    /**
     * @stable [14.11.2018]
     * @param {IPdfViewerProps} props
     * @param {IPdfViewerState} state
     */
    componentDidUpdate(props: IPdfViewerProps, state: IPdfViewerState): void;
    /**
     * @stable [14.11.2018]
     */
    componentWillUnmount(): void;
    /**
     * @stable [14.11.2018]
     */
    protected refresh(): void;
    /**
     * @stable [08.07.2018]
     * @returns {JSX.Element}
     */
    protected getRenderAreaElement(): JSX.Element;
    /**
     * @stable [08.07.2018]
     * @returns {JSX.Element}
     */
    protected gePreviewElement(): JSX.Element;
    /**
     * @stable [08.07.2018]
     * @returns {boolean}
     */
    protected readonly isProgressMessageShown: boolean;
}
