import { interfaces } from 'inversify';
/**
 * @stable [26.04.2018]
 * @param {interfaces.ServiceIdentifier<T>} serviceIdentifier
 * @returns {any}
 */
export declare const staticInjector: <T>(serviceIdentifier: string | symbol | interfaces.Newable<T> | interfaces.Abstract<T>) => T;
/**
 * @stable [26.04.2018]
 * @param target
 * @returns {(target: any) => any}
 */
export declare const provideInSingleton: (target: string | symbol | interfaces.Newable<any> | interfaces.Abstract<any>) => (target: any) => any;
/**
 * @stable [26.04.2018]
 * @param {interfaces.ServiceIdentifier<T> | {new(...args: AnyT[]): T}} contract
 * @param {{new(...args: AnyT[]): T}} implementation
 * @returns {interfaces.BindingWhenOnSyntax<any>}
 */
export declare const bindInSingleton: <T>(contract: string | symbol | interfaces.Newable<T> | interfaces.Abstract<T> | (new (...args: any[]) => T), implementation?: new (...args: any[]) => T) => interfaces.BindingWhenOnSyntax<any>;
/**
 * @stable [26.04.2018]
 * @param {interfaces.ServiceIdentifier<T> | {new(...args: AnyT[]): T}} contract
 * @param {{new(...args: AnyT[]): T}} implementation
 * @returns {interfaces.BindingWhenOnSyntax<any>}
 */
export declare const rebindInSingleton: <T>(contract: string | symbol | interfaces.Newable<T> | interfaces.Abstract<T> | (new (...args: any[]) => T), implementation?: new (...args: any[]) => T) => interfaces.BindingWhenOnSyntax<any>;
