import { IEntity, IKeyValue } from '../definitions.interface';
export declare function buildRoute(path: string, params: IKeyValue): string;
/**
 * @stable [01.12.2018]
 * @param {string} path
 * @returns {string}
 */
export declare const buildNormalizedPath: (path: string) => string;
/**
 * @stable [21.08.2018]
 * @param {string} path
 * @param {TEntity} entity
 * @param {IKeyValue} params
 * @returns {string}
 */
export declare const buildEntityRoute: <TEntity extends IEntity>(path: string, entity?: TEntity, params?: IKeyValue) => string;
/**
 * @stable [23.10.2018]
 * @param {string} path
 * @param {IKeyValue} routes
 * @returns {{route: string; bindings: IKeyValue}}
 */
export declare const findUrlPattern: (path: string, routes: IKeyValue) => {
    route: string;
    bindings: IKeyValue;
};
