"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function isDef(value) {
    return !isUndef(value);
}
exports.isDef = isDef;
function isUndef(value) {
    return typeof value === 'undefined';
}
exports.isUndef = isUndef;
function isNull(value) {
    return value === null;
}
exports.isNull = isNull;
function isFn(value) {
    return typeof value === 'function';
}
exports.isFn = isFn;
/**
 * @stable [01.08.2018]
 * @param {AnyT} value
 * @returns {boolean}
 */
exports.isNumber = function (value) { return typeof value === 'number'; };
/**
 * @stable [01.08.2018]
 * @param {AnyT} value
 * @returns {boolean}
 */
exports.isNumberLike = function (value) { return /^-?[0-9]\d*(\.\d+)?$/.test(String(value)); };
function isBoolean(value) {
    return typeof value === 'boolean';
}
exports.isBoolean = isBoolean;
function isString(value) {
    return typeof value === 'string';
}
exports.isString = isString;
exports.isPrimitive = function (v) {
    return exports.isNumber(v)
        || isString(v)
        || isBoolean(v);
};
exports.isObject = function (v) {
    return Object.prototype.toString.call(v) === '[object Object]';
};
//# sourceMappingURL=type.js.map